source: issm/trunk-jpl/scripts/jenkins.sh@ 16595

Last change on this file since 16595 was 16595, checked in by Eric.Larour, 11 years ago

CHG: no nightly locks on this type of checks

  • Property svn:executable set to *
File size: 7.9 KB
Line 
1#!/bin/bash
2#This bash script calls the nightlyrun.m matlab file to run our nightly test decks.
3#It then processes the results and sends an email to the Ice developpers.
4
5#some functions
6function timer() #{{{
7{
8 if [[ $# -eq 0 ]]; then
9 echo $(date '+%s')
10 else
11 local stime=$1
12 etime=$(date '+%s')
13
14 if [[ -z "$stime" ]]; then stime=$etime; fi
15
16 dt=$((etime - stime))
17 ds=$((dt % 60))
18 dm=$(((dt / 60) % 60))
19 dh=$((dt / 3600))
20 printf '%d:%02d:%02d' $dh $dm $ds
21 fi
22} #}}}
23function todaydate() #{{{
24{
25 suffix=`date | awk '{printf("%s-%s-%s %s",$2,$3,$6,$4);}'`
26 echo $suffix;
27} #}}}
28function host_name() #{{{
29{
30 #return host name depending on the OS
31 if [ "$1" = "win7" ]
32 then
33 HOST_NAME=`hostname | sed 's/-//g'`;
34 else
35 HOST_NAME=`hostname -s | sed 's/-//g'`;
36 fi
37 echo $HOST_NAME;
38} #}}}
39function pause() #{{{
40{
41pid=`ps aux -W | grep $1 | awk '{printf("%s\n",$1);}'`
42
43while [ -n "$pid" ]
44do
45 pid=`ps aux -W | grep $1 | awk '{printf("%s\n",$1);}'`
46done
47}
48#}}}
49
50#Get configuration
51#Source config file{{{
52if [ $# -ne 1 ];
53then
54 #no config file specified: exit
55 echo "no config file specified. Exiting..." >&2 # Error message to stderr.
56 exit 1
57fi
58if [ ! -f "$1" ]
59then
60 echo "File $1 not found!" >&2 # Error message to stderr.
61 exit 1
62fi
63source $1;
64#}}}
65#Export ISSM_* variables{{{
66export ISSM_DIR
67export ISSM_ARCH
68#}}}
69#Initialize variables {{{
70TODAY=$(todaydate);
71HOST_NAME=$(host_name $OS);
72OS=$(uname -s)
73START_TIME=$(timer);
74ISSM_RELEASE=$(basename $(echo $REPOSITORY));
75USER=$(whoami);
76INIT_PATH=$(pwd);
77#}}}
78
79#Installation ISSM
80#Checkout/update/none ISSM if requested (ISSM_INSTALLATION){{{
81if [ "$ISSM_INSTALLATION" == "checkout" ]
82then
83 rm -rf $ISSM_RELEASE
84 svn checkout "$REPOSITORY"
85elif [ "$ISSM_INSTALLATION" == "update" ]
86then
87 cd $ISSM_DIR
88 svn update
89elif [ "$ISSM_INSTALLATION" == "none" ]
90then
91 echo "Skipping ISSM installation"
92else
93 echo "ISSM_INSTALLATION supported values are: checkout, update and none. Exiting..." >&2 # Error message to stderr.
94 exit 1
95fi
96source $ISSM_DIR/etc/environment.sh
97#}}}
98#create matlab's installation sript {{{
99cat << END > $ISSM_DIR/externalpackages/matlab/install.sh
100#!/bin/bash
101rm -rf install
102ln -s $MATLAB_PATH install
103END
104#}}}
105#install/copy/none external packages (ISSM_EXTERNALPACKAGES){{{
106if [ "$ISSM_EXTERNALPACKAGES" == "install" ]
107then
108
109 cd $ISSM_DIR/externalpackages
110
111 #number of packages:
112 NUMPACKAGES=$(($(echo $EXTERNALPACKAGES | wc -w )/2))
113
114 for ((i=1;i<=$NUMPACKAGES;i++))
115 do
116 NUM1=$((2*$i-1))
117 NUM2=$((2*$i))
118 PACKAGENAME=$(echo $EXTERNALPACKAGES | cut -d " " -f $NUM1-$NUM1)
119 PACKAGEINST=$(echo $EXTERNALPACKAGES | cut -d " " -f $NUM2-$NUM2)
120
121 cd $PACKAGENAME
122 echo "======================================================";
123 echo " Installing $PACKAGENAME (see compil.log) ";
124 echo "======================================================";
125 ./$PACKAGEINST > compil.log
126 if [ $? -ne 0 ]; then
127 echo "======================================================";
128 echo " ERROR: installation of $PACKAGENAME failed ";
129 echo "======================================================";
130 fi
131 source $ISSM_DIR/etc/environment.sh
132 cd ..
133 done
134
135elif [ "$ISSM_EXTERNALPACKAGES" == "copy" ]
136then
137 cd $ISSM_DIR
138 rm -rf externalpackages
139 cp -Rf $EXTERNALPACKAGESDIR ./
140elif [ "$ISSM_EXTERNALPACKAGES" == "link" ]
141then
142 cd $ISSM_DIR
143 rm -rf externalpackages
144 ln -s $EXTERNALPACKAGESDIR .
145elif [ "$ISSM_EXTERNALPACKAGES" == "none" ]
146then
147 echo "Skipping external packages installation"
148else
149 echo "ISSM_EXTERNALPACKAGES supported values are: install, copy and none. Exiting..." >&2 # Error message to stderr.
150 exit 1
151fi
152source $ISSM_DIR/etc/environment.sh
153#}}}
154#ISSM compilation yes/no (ISSM_COMPILATION) {{{
155if [ "$ISSM_COMPILATION" == "yes" ]
156then
157 cd $ISSM_DIR
158 make uninstall
159 make clean
160 make distclean
161 ./scripts/automakererun.sh
162 cat > configure.sh << EOF
163./configure $ISSM_CONFIG
164EOF
165 chmod 700 configure.sh
166 ./configure.sh
167
168 #4: compile and install ISSM
169 if [ $NUMCPUS_INSTALL -gt 1 ]
170 then
171 echo "Making with " $NUMCPUS_INSTALL " cpus"
172 make -j $NUMCPUS_INSTALL install
173 else
174 make install
175 fi
176elif [ "$ISSM_COMPILATION" == "no" ]
177then
178 echo "Skipping ISSM compilation"
179else
180 echo "ISSM_COMPILATION supported values are: yes and no. Exiting..." >&2 # Error message to stderr.
181 exit 1
182fi
183#}}}
184
185#Prepare info.log
186#{{{
187rm -rf $ISSM_DIR/nightlylog
188mkdir $ISSM_DIR/nightlylog
189INSTALL_TIME=$(timer)
190ELAPSED=$(timer $START_TIME)
191VERSION=$(svnversion $ISSM_DIR)
192cat << END > $ISSM_DIR/nightlylog/info.log
193name: $(echo $NAME)
194today: $(echo $TODAY)
195user: $(echo $USER)
196host: $(echo $HOST_NAME)
197OS: $(echo $OS)
198release: $(echo $ISSM_RELEASE)
199init_path: $(echo $INIT_PATH)
200is_matlab: $(echo $MATLAB_TEST)
201is_python: $(echo $PYTHON_TEST)
202elapsed_install: $(echo $ELAPSED)
203version: $(echo $VERSION)
204END
205#}}}
206
207#matlab tests
208if [ $MATLAB_TEST -eq 1 ]; then
209#Launch all tests on different cpus {{{
210MATLAB_START_TIME=$(timer);
211for (( i=1;i<=$NUMCPUS_RUN;i++ ))
212do
213 #Launch matlab and the nightly run script
214 cat > $ISSM_DIR/nightlylog/matlab_run$i.m << EOF
215 warning off %necessary to avoid a info.log of several Go for parallel runs
216 try,
217 $(if [ "$MATLAB_NROPTIONS" = "" ]
218 then
219 echo "runme('output','nightly','rank',$i,'numprocs',$NUMCPUS_RUN);"
220 else
221 echo "runme($MATLAB_NROPTIONS,'output','nightly','rank',$i,'numprocs',$NUMCPUS_RUN);"
222 fi
223 )
224 catch me,
225 %An error occured, get report and exit
226 message=getReport(me)
227 directory=strsplit(pwd,'/');
228 fid=fopen([issmdir '/nightlylog/matlaberror.log'], 'at');
229 fprintf(fid,'\nMatlab error occured in: %s\n\n',directory{end});
230 fprintf(fid,'%s',message);
231 fclose(fid);
232 end
233 disp('MATLABEXITEDCORRECTLY');
234 exit
235EOF
236 cd $ISSM_DIR/test/NightlyRun
237 matlab -nojvm -nosplash -r "addpath $ISSM_DIR/src/m/dev; devpath; addpath $ISSM_DIR/nightlylog/; matlab_run$i" -logfile $ISSM_DIR/nightlylog/matlab_log$i.log &
238done
239
240#wait until matlab closes
241if [ "$OS" = "win7" ]; then
242 pause MATLAB
243else
244 wait
245fi
246
247#concatenate reports
248cd $ISSM_DIR/nightlylog/
249rm matlab_log.log
250for (( i=1;i<=$NUMCPUS_RUN;i++ ))
251do
252 cat matlab_log$i.log >> matlab_log.log
253done
254#}}}
255#Complete info.log {{{
256if [ $(cat matlab_log.log | grep "MATLABEXITEDCORRECTLY" | wc -l) -eq $NUMCPUS_RUN ]
257then
258 MATLABCRASH=0
259else
260 MATLABCRASH=1
261fi
262ELAPSED=$(timer $MATLAB_START_TIME)
263cat << END >> $ISSM_DIR/nightlylog/info.log
264elapsed_matlab: $(echo $ELAPSED)
265matlab_crash: $(echo $MATLABCRASH)
266END
267#}}}
268fi
269
270#python tests
271if [ $PYTHON_TEST -eq 1 ]; then
272#Launch all tests on different cpus {{{
273PYTHON_START_TIME=$(timer);
274export PYTHONSTARTUP=$ISSM_DIR/src/m/dev/devpath.py
275for (( i=1;i<=$NUMCPUS_RUN;i++ ))
276do
277 cd $ISSM_DIR/test/NightlyRun
278 ./runme.py --output=nightly --rank=$i --numprocs=$NUMCPUS_RUN $PYTHON_NROPTIONS 2>&1 > $ISSM_DIR/nightlylog/python_log$i.log &
279done
280
281#wait until python closes
282if [ "$OS" = "win7" ]; then
283 pause MATLAB
284else
285 wait
286fi
287
288#concatenate reports
289cd $ISSM_DIR/nightlylog/
290rm python_log.log
291for (( i=1;i<=$NUMCPUS_RUN;i++ ))
292do
293 cat python_log$i.log >> python_log.log
294done
295#}}}
296#Complete info.log {{{
297if [ $(cat python_log.log | grep "PYTHONEXITEDCORRECTLY" | wc -l) -eq $NUMCPUS_RUN ]
298then
299 PYTHONCRASH=0
300else
301 PYTHONCRASH=1
302fi
303ELAPSED=$(timer $PYTHON_START_TIME)
304cat << END >> $ISSM_DIR/nightlylog/info.log
305elapsed_python: $(echo $ELAPSED)
306python_crash: $(echo $PYTHONCRASH)
307END
308#}}}
309fi
310
311#complete info.log
312#{{{
313ELAPSED=$(timer $START_TIME)
314cat << END >> $ISSM_DIR/nightlylog/info.log
315elapsed_total: $(echo $ELAPSED)
316END
317#}}}
318
319#Send Report
320#Build html report {{{
321cd $ISSM_DIR/nightlylog/
322sh ../scripts/report.sh
323echo "html report located in $ISSM_DIR/nightlylog/report.html"
324#}}}
325#send mail if requested (SKIPMAIL) {{{
326if [ "$SKIPMAIL" != "yes" ]
327then
328 echo "sending report..."
329 for i in `echo $MAILINGLIST`; do
330
331cat - $ISSM_DIR/nightlylog/report.html <<HERE | /usr/lib/sendmail -oi -t
332From: "ISSM Nightly run" <$EMAIL_ADRESS>
333To: $i
334Subject: ISSM nightly runs report: $NAME
335Mime-Version: 1.0
336Content-Type: text/html
337HERE
338 done
339fi
340#}}}
341
342#remove lock file
343#{{{
344cd $ISSM_DIR/../
345rm NIGHTLYLOCK
346#}}}
Note: See TracBrowser for help on using the repository browser.